<?php
namespace Teknisa\COZ\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class Coz10600 extends \Zeedhi\Framework\Controller\Report {

    protected $requisicaoPlanejamentoProducaoService;
    protected $distribuicaoProducaoController;
    protected $coz10600Service;
    protected $listaController;
    protected $entityManager;
    protected $reportName;
    protected $nrlistaetiq;
    protected $birtStrategy;
    protected $nrlistaFilialSetor;
    protected $novoCodigo;

    public function __construct(ReportService $reportService, $entityManager, $requisicaoPlanejamentoProducaoService, $distribuicaoProducaoController, $coz10600Service, $listaController, $birtStrategy, $novoCodigo) {
        $this->requisicaoPlanejamentoProducaoService = $requisicaoPlanejamentoProducaoService;
        $this->distribuicaoProducaoController = $distribuicaoProducaoController;
        $this->coz10600Service = $coz10600Service;
        $this->listaController = $listaController;
        $this->entityManager = $entityManager;
        $this->birtStrategy  = $birtStrategy;
        $this->novoCodigo = $novoCodigo;
        
        parent::__construct($reportService);
    }

    protected $reportMapping = array (
    'dis10600' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10601' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10602' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRLISTASERV' => 'P_NRLISTASERV',
                'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRORG' => 'P_NRORG'
            )
        ),
    'dis10603' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis10604' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'NRORG' => 'P_NRORG',
                'CDCENTRAL' => 'P_CDCENTRAL',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'DTINICIAL' => 'P_DTCONSUMOINI',
                'DTFINAL' => 'P_DTCONSUMOFIN',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'CDPICTPROD'=> 'P_CDPICTPROD'
            )
        ),
    'dis15504' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'NRORG' => 'P_NRORG',
                'DTINICIAL' => 'P_DTINI',
                'DTFINAL' => 'P_DTFIN',
                'LISTAPRODUTO' => 'P_LISTAPROD',
                'NRDISTPROD' => 'P_NRDISTPROD',
                'NRLISTASERV' => 'P_NRLISTASERV',
                'CDCENTRAL' => 'P_CDCENTRAL'
            )
        ),
    'dis10605' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10606' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'NRLISTAETIQ' => 'P_NRLISTAETIQ',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRORG' => 'P_NRORG'
                )
        ),
    'dis10607' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'DTINICIAL' => 'P_DTCONSUMOINI',
                    'DTFINAL' => 'P_DTCONSUMOFIN',
                    'NRORG' => 'P_NRORG',
                    'CDCENTRAL' => 'P_CDCENTRAL',
                    'NRDISTPROD' => 'P_NRDISTPROD',
                    'NRLISTASERV' => 'P_NRLISTASERV',
                    'LISTAPRODUTO' => 'P_LISTAPROD'
                )
        ),
    'dis10608' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
                array (
                    'DTINICIAL'    => 'P_DTINI',
                    'DTFINAL'      => 'P_DTFIN',
                    'NRORG'        => 'P_NRORG',
                    'CDCENTRAL'    => 'P_CDCENTRAL',
                    'NMCENTRAL'    => 'P_NMCENTRAL',
                    'NRDISTPROD'   => 'P_NRDISTPROD',
                    'NRLISTASERV'  => 'P_NRLISTASERV',
                    'LISTAPRODUTO' => 'P_LISTAPROD',
                    'CDPICTPROD'   => 'P_CDPICTPROD',
                    'CDSETOR'      => 'P_CDSETOR'
                )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
        
        $row['CDSETOR'] = $this->montaListaFilialSetor($row['NRORG'], $row['LISTASETOR']);

        $listaFilial = $row["LISTAFILIAL"] = $this->coz10600Service->retornaFiliais((array)$row);
        $row["LISTAGRUPSERV"] = $this->coz10600Service->retornaGrupServ((array)$row);
        $row['SERVICOFILIAL'] = $this->coz10600Service->retornaServico((array)$row);
        $listaServico = $row["LISTASERVICO"] = $this->coz10600Service->concatArray($row['SERVICOFILIAL'], 'SERVICO');
        $row["LISTAPRODUTO"] = $this->coz10600Service->retornaProduto((array)$row);
        $this->reportName = $row['CD_REPORT_NAME'];
        $this->nrorg = $row['NRORG'] = $this->coz10600Service->environment->getNrorgTrab();
        $cdcentral = $row['CDCENTRAL'];
        $dtinicial = $row['DTINICIAL'];
        $dtfinal = $row['DTFINAL'];
        $listaproduto = $row['LISTAPRODUTO'];
        $row['NRLISTASERV'] =  $this->listaController->geraListaServico($row['LISTASERVICO'], $row['NRORG']);

        if($this->reportName == 'dis10602' or $this->reportName == 'dis10605' or $this->reportName == 'dis10606') {

            $lista = $this->distribuicaoProducaoController->retornaListaEtiquetas($cdcentral, $dtinicial, $dtfinal, $row['NRLISTASERV'] , $listaproduto);
            if ($lista) {
                $this->nrlistaetiq
                    = $this->requisicaoPlanejamentoProducaoService->geraLista(
                    $this->nrorg, $lista, '-'
                );
            } else {
                $this->nrlistaetiq = 'X';
            }

            $row['NRLISTAETIQ'] = $this->nrlistaetiq;

            if ($this->reportName == 'dis10605') {
                $row["LISTASERVICO"] = $listaServico ? $listaServico : 'T';
                $row["LISTAFILIAL"] = $listaFilial ? $listaFilial : 'T';
            }
        }
    }
    
    public function montaListaFilialSetor($nrorg, $listaSetor){
        $filiaisSetor = rtrim($listaSetor, '_');
        $arrayFiliaisSetor = explode('_', $filiaisSetor);
        if ($arrayFiliaisSetor[0]) {
            $this->nrlistaFilialSetor = $this->novoCodigo->getCodeByTableName(
                "LISTA", $nrorg
            );
            foreach ($arrayFiliaisSetor as $setor) {
                $FilialSetorParametros = array(
                    "NRORG" => $nrorg, "NRLISTA" => $this->nrlistaFilialSetor,
                    "CDLISTA" => $setor
                , "DTULTATULIST" => '', "NRORGINCLUSAO" => '',
                    "DTINCLUSAO" => ''
                , "CDOPERINCLUSAO" => '', "IDATIVO" => '', "CDOPERULTATU" => ''
                , "DTULTATU" => '', "NRORGULTATU" => '', "DTULTATUPRFIL" => ''
                , "__is_new" => true
                );
                $this->saveLista($FilialSetorParametros);
            }
        } else {
            $this->nrlistaFilialSetor = 0;
        }
        return $this->nrlistaFilialSetor;
    }
    
    public function saveLista($param){
        $request = new DTO\Request\Row($param, "save", "/dummy", " ");
        $response = new DTO\Response();
        $this->listaController->save($request, $response);
    }

}